#include <stdio.h>
#include <stdlib.h>
/*#define FOR */
/*#define WHILE*/

/*
vamos a hacer un and lógico entre el número argumento y una máscara.
mascara valor      AND
0         0         0
0         1         0
1         0         0
1         1         1

dec bin   hexadecimal:
0   0000  0
1   0001  1
2   0010  2
3   0011  3
4   0100  4
5   0101  5
6   0110  6
7   0111  7
8   1000  8
9   1001  9
10  1010  A
11  1011  B
12  1100  C
13  1101  D
14  1110  E
15  1111  F
*/

int main(int argc, char* argv[]){
 if (argc == 2){
  int num, i, mascara;
  int bits[sizeof(int)*8];
  mascara = 0x00000001; /* en hexadecimal, son 32 bits, podria haber dicho mascara = 1; */
 
  num = atoi(argv[1]);
  
#ifdef FOR
  printf("usando for\n");
  for (i=0;i<sizeof(int)*8;i++){			
   bits[i] = (num & mascara);   /* 0xAFC00031 */
   if( i < 5)
     printf("num %d mascara %d and %d\n",num,mascara, num&mascara);
   num >>=1;  /* num = num>>1; */
   /* mascara <<= 1; esto no funciona! */
}
#else

#ifdef WHILE
/* con while (podemos nunca entrar en el loop)	*/
  printf("usando while\n");
  i=0;
  while(i<sizeof(int)*8){
   bits[i] = (num & mascara);
   num >>= 1;
   i++;
   printf("%d ",i);
   } 
   printf ("\n");
#else
   printf("\nusando do while\n");
/* con do-while (entramos en el loop al menos una vez)	*/
  i=0;
  do{
   bits[i] = (num & mascara);
   num >>= 1;
   i++;
   printf("%d ",i);
  } while(i<sizeof(int)*8); //¿Qué pasa si usamos i++?
  printf("\n");
#endif

#endif

 for (i=sizeof(int)*8-1;i>=0;i--)
   printf("%d",bits[i]);
  printf("\n");
  return 0;
 }
 else{
  printf("¡ERROR! uso: ./p3e1 [numero]\n");
  return 1;
 }
}
